'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = createFilter;

var _path = require('path');

var _micromatch = require('micromatch');

var _micromatch2 = _interopRequireDefault(_micromatch);

var _ensureArray = require('./utils/ensureArray');

var _ensureArray2 = _interopRequireDefault(_ensureArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createFilter(include, exclude) {
	var getMatcher = function getMatcher(id) {
		return isRegexp(id) ? id : { test: _micromatch2.default.matcher((0, _path.resolve)(id).split(_path.sep).join('/')) };
	};
	include = (0, _ensureArray2.default)(include).map(getMatcher);
	exclude = (0, _ensureArray2.default)(exclude).map(getMatcher);

	return function (id) {

		if (typeof id !== 'string') return false;
		if (/\0/.test(id)) return false;

		id = id.split(_path.sep).join('/');

		for (var i = 0; i < exclude.length; ++i) {
			var matcher = exclude[i];
			if (matcher.test(id)) return false;
		}

		for (var _i = 0; _i < include.length; ++_i) {
			var _matcher = include[_i];
			if (_matcher.test(id)) return true;
		}

		return !include.length;
	};
}

function isRegexp(val) {
	return val instanceof RegExp;
}